function out=cutsection(i1,i2,X);
%CUTSECTION(i1,i2,X)
%  Given a Matrix X, of n rows and m columns cutsection cuts out a
%  section of the rows corresponding to the interval [i1 i2].
%  If i1 and or i2 are decimal numbers, CUTSECTION will interpolate
%  to get the ends of the section correct.

le=size(X,1);

if (i1<1 & i2<1) | (i1>le & i2>le) | i1==i2
    out=[];
    return
end

if i1<1
    i1=1;
end

if i1>=le
    out=[];
    return
end

if i2>le
    i2=le;
end

if i2<i1
    out=[];
    return
end

iint1=floor(i1);
frac1=i1-iint1;

if i2==le
    iint2=le-1;
    frac2=1;    
else
    iint2=floor(i2);
    frac2=i2-iint2;
end

extra1=X(iint1,:)*(1-frac1)+X(iint1+1,:)*frac1;
extra2=X(iint2,:)*(1-frac2)+X(iint2+1,:)*frac2;

if frac2==0
    extra2=[];
end

out=[extra1;X(iint1+1:iint2 , :);extra2];

