function out=decimalindex(t,tvector)
%DECIMALINDEX(t,tvector)
%  Given a 't' and a 'tvector', decimalindex returns the
%  linearly interpolated index. If the t-value is outside of
%  the range of t (which is assumed to be monotonically increasing 
%  or decreasing) decimalindex returns the bordervalue of tvector.

t1=tvector(1);
t2=tvector(length(tvector));

if t2>t1
    
    if t>=t2
	out=length(tvector);
    elseif t<=t1
	out=1;
    else
	
	[temp,i]=min(abs(tvector-t));
	
	%Fixing so i is to the left of the real point
	
	if i==1
	    %fine
	elseif i==length(t)
	    i=i-1;
	elseif t<tvector(i)
	    i=i-1;
	end
	
	fraction=(t-tvector(i)) / (tvector(i+1)-tvector(i));
	out=i+fraction;
    end
    
else
    
    if t<=t2
	out=length(tvector);
    elseif t>=t1
	out=1;
    else
	
	[temp,i]=min(abs(tvector-t));
	
	%Fixing so i is to the left of the real point
	
	if i==1
	    %fine
	elseif i==length(t)
	    i=i-1;
	elseif t>tvector(i)
	    i=i-1;
	end
	
	fraction=abs(t-tvector(i)) / abs(tvector(i+1)-tvector(i));
	out=i+fraction;
    end
        
end
    





