function out=distonsurf(X,Y,Z,xbase,ybase,xvec,yvec,varargin)
%DISTONSURF(X,Y,Z,xbase,ybase,xvec,yvec,OPTIONS)
%Calculates the proper cumulative distance of a coordinate line - 
%on a surface

default={
    'edgecut','on';    %Cutting objects if they pass the basesurface
	};      

eval(setvalues)

if size(X,1)~=length(xbase)
    error('RJ: No of elements in base1 not corresponding to no of rows in X')
end

if size(X,2)~=length(ybase)
    error('RJ: No of elements in base2 not corresponding to no of columns in X')
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%% The real stuff starts here %%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

x=xvec;
y=yvec;

rjempty=0;
if isequal(edgecut,'on')
    [x y]=cutthecrap(xbase,ybase,x,y);
    if isempty(x) | isempty (y)
	rjempty=1;
    end
end

%%%%%%%%%%% Finding positions and normals %%%%%%%%%

position=zeros(length(x),3);           %Initializing

for nr=1:length(x);
    i=decimalindex(x(nr),xbase);
    j=decimalindex(y(nr),ybase);
    position(nr,:)=rjfinddecimalposition(i,j,X,Y,Z);
end


le=size(position,1);
pointing=position(2:le,:)-position(1:le-1,:);
tempdistance=rjnorm(pointing);             
tempcumdistance=[0 cumsum(tempdistance)];

out=tempcumdistance;












