function out=findvalue(t,tvector,xvector)
%FINDVALUE(t,tvector,xvector)
%  Given a tvector and a corresponding xvector Findvalue returns the
%  linearly interpolated x at the given t. If the t-value is outside of
%  the range of t (which is assumed to be monotonically increasing
%  or decreasing) Findvalue returns the bordervalue of tvector

idec=decimalindex(t,tvector);
i=floor(idec);
fraction=idec-i;

if i==length(tvector)
    out=xvector(length(xvector));
else
    
    out=xvector(i)*(1-fraction) + fraction*xvector(i+1);
end
