function [tline,rightline,leftline,rightphoton,leftphoton,topline]=...
         generateminkowski(X,Y,Z,xbase,ybase,x,y,generatorstring,varargin)

default={
    'msize',1;
    'lightconefactor',0.75;
    'number',10;                %A rough measure of the number of points
    'extrafactor',2;            %How far extra to extend the lines, they
                                %will be cut later.
    'lockorigin','off';         %If to hold metric and generator fix as
                                %specifed at the origin or not
    'extraangle',0;             %Extra turning angle
    'xcentershift','off';       %Shifts the lightcone (in coordinates), after it is
                                %created, to make the middle lightcone point,
                                %rather thatn the origin,  sit at the specified
                                %x-coordinate (mainly for intrinsically
                                %flat surfaces)
    'ycentershift','off';       %Same as xcentershift, but for y
    'lfactor', 2/3;              %How far up the triangle the middle
                                %lies. 2/3 for the center of mass
    'xclosed','off';            %Closed boundary conditions
    'yclosed','off';            %Closed boundary conditions
    'fixdir',[];                %If non-zero it overrules the generator
                                %function for gendir and locks the origin.
    };
eval(setvalues);

maxlength=msize*extrafactor;
sendset={'lockorigin',lockorigin,'xclosed',xclosed,'yclosed',yclosed,'fixdir',fixdir};

tline=findline(X,Y,Z,xbase,ybase,x,y,generatorstring,'maxlength', ...
	       maxlength,'langle',0+extraangle,'number',number*extrafactor,sendset{:});

rightline=findline(X,Y,Z,xbase,ybase,x,y,generatorstring,'maxlength', ...
		   maxlength,'langle',90+extraangle,'number',number*extrafactor,...
		   sendset{:});

leftline=findline(X,Y,Z,xbase,ybase,x,y,generatorstring,'maxlength', ...
	       maxlength,'langle',-90+extraangle,'number',number*extrafactor,...
		  sendset{:});

rightphoton=findline(X,Y,Z,xbase,ybase,x,y,generatorstring,'maxlength', ...
	       maxlength*sqrt(2),'langle',45+extraangle,'number',number*extrafactor,...
		     sendset{:});

leftphoton=findline(X,Y,Z,xbase,ybase,x,y,generatorstring,'maxlength', ...
	       maxlength*sqrt(2),'langle',-45+extraangle,'number',number*extrafactor,...
		    sendset{:});

if isequal(lockorigin,'on')
    lockpoint=[x y];   %Sets the origin of the system as the locking
                       %point for metric and generators
else
    lockpoint=[];
end

%%%%%%%%%%%%%%%%% The top line %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

distvec=distonsurf(X,Y,Z,xbase,ybase,tline{1},tline{2});
x=findvalue(msize*lightconefactor,distvec,tline{1});
y=findvalue(msize*lightconefactor,distvec,tline{2});

temp1=findline(X,Y,Z,xbase,ybase,x,y,generatorstring,'maxlength', ...
	       maxlength,'langle',90+extraangle,'number',number*extrafactor,...
	       sendset{:},...
	       'lockpoint',lockpoint);

temp2=findline(X,Y,Z,xbase,ybase,x,y,generatorstring,'maxlength', ...
	       maxlength,'langle',-90+extraangle,'number',number*extrafactor,...
	       sendset{:},...
	       'lockpoint',lockpoint);

x1=temp1{1};
y1=temp1{2};
x2=temp2{1};
y2=temp2{2};

xtopline=[fliplr(x1) x2(2:length(x2))];    %findline returns rowvectors ...
ytopline=[fliplr(y1) y2(2:length(y2))];    %findline returns rowvectors ...

topline={xtopline,ytopline};

%%% Shifting the center afterwards %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

xt=tline{1};
yt=tline{2};
%lfactor=1/2;       %2/3 for center of mass
le=length(xt);

if isequal(xcentershift,'on')
    deltax=xt(floor(le*lfactor*lightconefactor/extrafactor))-xt(1);
else
    deltax=0;
end

if isequal(ycentershift,'on')
    deltay=yt(floor(le*lfactor*lightconefactor/extrafactor))-yt(1);
else
    deltay=0;
end

tline={tline{1}-deltax,tline{2}-deltay};
rightline={rightline{1}-deltax,rightline{2}-deltay};
leftline={leftline{1}-deltax,leftline{2}-deltay};
rightphoton={rightphoton{1}-deltax,rightphoton{2}-deltay};
leftphoton={leftphoton{1}-deltax,leftphoton{2}-deltay};
topline={topline{1}-deltax,topline{2}-deltay};









