function [guu,guv,gvv,outofbounds]=getmetric(X,Y,Z,ubase,vbase,u,v)
%This is a function to estimate the local metric of a parametrized surface.
%It assumes that u and v both lie well within the borders of ubase and vbase

su=max(ubase)-min(ubase);
sv=max(vbase)-min(vbase);

du=su/10^7;
dv=sv/10^7;

i=decimalindex(u,ubase);
j=decimalindex(v,vbase);


position0=rjfinddecimalposition(i,j,X,Y,Z);

i=decimalindex(u+du,ubase);
j=decimalindex(v+0,vbase);
positionu=rjfinddecimalposition(i,j,X,Y,Z);

i=decimalindex(u,ubase);
j=decimalindex(v+dv,vbase);
positionv=rjfinddecimalposition(i,j,X,Y,Z);

duvec=positionu-position0;
dvvec=positionv-position0;

guu=sum(duvec.*duvec)/du^2;
gvv=sum(dvvec.*dvvec)/dv^2;
guv=sum(dvvec.*duvec)/(du*dv);

















