function out=rjaddextra(x,number)
%RJADDEXTRA(x,number)
% Adds linearly interpolated elements between the already existing
% elements of a vector x. How many extra elements that should be
% insterted is determined by 'number'. See also rjremoveextra
%
% Example;
%
% rjaddextra([0 1 3],2)
%
% ans =
%
%         0    0.3333    0.6667    1.0000    1.6667    2.3333    3.0000

s=size(x);
if s(1)>s(2)    %Initializing
    x=x';
    flipflag='on';
else
    flipflag='off';
end

out=zeros(1,(length(x)-1)*(number+1)+1);

for i=1:length(x)-1
    temp=linspace(x(i),x(i+1),number+2);
    outi=(i-1)*(number+1)+1;
    out(outi:outi+number)=temp(1:number+1);
end

out(length(out))=x(length(x));

if isequal(flipflag,'on')
    out=out';
end





