function out=rjfindcoordinateposition(X,Y,Z,xbase,ybase,x,y);
% RJFINDCOORDINATEPOSITION(X,Y,Z,x,y,xbase,ybase)
%    Given a surface represented by X,Y and Z (matrices) and two base
%    coordinate vectors xbase and ybase, rjfindcoordinateposition gets
%    the threedimensional position of the coordinate point (x,y) on the surface 

if size(X,1)~=length(xbase)
    error('RJ: First dimension of X not corresponding to length of xbase')
end

if size(X,2)~=length(ybase)
    error('RJ: Second dimension of X not corresponding to length of ybase')
end

i=decimalindex(x,xbase);
j=decimalindex(y,ybase);
%inew=length(xbase)-i+1;  
%jnew=length(ybase)-j+1;  
out=rjfinddecimalposition(i,j,X,Y,Z)






