function out=rjfinddecimalnormal(i,j,X,Y,Z);
% RJFINDNORMAL
%    Given a surface represented by X,Y and Z (matrices) and two decimal 
%    indices i and j Rjfindnormal returns the normal vektor of the node
%    in question.

maxi=size(X,1);
maxj=size(X,2);

%%%% Insuring that i and j stay within the grid %%%%%%%%%

if i>maxi
    i=maxi;
end

if i<1
    i=1;
end

if j>maxj
    j=maxj;
end

if j<1
    j=1;
end

if i==maxi
    iint=maxi-1;
    ifrac=1;
else
    iint=floor(i);
    ifrac=i-iint;
end

if j==maxj
    jint=maxj-1;
    jfrac=1;
else
    jint=floor(j);
    jfrac=j-jint;
end

%%%% Calculating the average weighted normal

norm11=rjfindnormal(iint,jint,X,Y,Z);
norm12=rjfindnormal(iint,jint+1,X,Y,Z);
norm21=rjfindnormal(iint+1,jint,X,Y,Z);
norm22=rjfindnormal(iint+1,jint+1,X,Y,Z);
weightnorm=...
    norm11*(1-ifrac)*(1-jfrac)+...
    norm12*(1-ifrac)*jfrac+...
    norm21*ifrac*(1-jfrac)+...
    norm22*ifrac*jfrac;

out=weightnorm/norm(weightnorm);











