function out=rjfinddecimalposition(i,j,X,Y,Z);
% RJFINDDECIMALPOSITION(i,j,X,Y,Z)
%    Given a surface represented by X,Y and Z (matrices) and two decimal 
%    indices i and j Rjfinddecimalposition returns the position of the point in question.


maxi=size(X,1);
maxj=size(X,2);

%%%% Insuring that i and j stay within the grid %%%%%%%%%

if i>maxi
    i=maxi;
end

if i<1
    i=1;
end

if j>maxj
    j=maxj;
end

if j<1
    j=1;
end

if i==maxi
    iint=maxi-1;
    ifrac=1;
else
    iint=floor(i);
    ifrac=i-iint;
end

if j==maxj
    jint=maxj-1;
    jfrac=1;
else
    jint=floor(j);
    jfrac=j-jint;
end

%%%% Calculating the average weighted position %%%%%%%

matrixset={X,Y,Z};

for nr=1:3
    M=matrixset{nr};

    M11=M(iint,jint);
    M12=M(iint,jint+1);
    M21=M(iint+1,jint);
    M22=M(iint+1,jint+1);
    
    position(nr)=...
	M11*(1-ifrac)*(1-jfrac)+...
	M12*(1-ifrac)*jfrac+...
	M21*ifrac*(1-jfrac)+...
	M22*ifrac*jfrac;
end

out=position;






