function normal=rjfindnormal(i,j,X,Y,Z);
% RJFINDNORMAL(i,j,X,Y,Z)
%    Given a surface represented by X,Y and Z (matrices) and two integer
%    indices i and j Rjfindnormal returns the normal vektor of the node
%    in question.

pos(:,:,1)=X;
pos(:,:,2)=Y;
pos(:,:,3)=Z;

warning off
try;vec1=permute(pos(i+1,j,:)-pos(i,j,:),[1 3 2]);catch; vec1=[];end;
try;vec2=permute(pos(i,j+1,:)-pos(i,j,:),[1 3 2]);catch; vec2=[];end;
try;vec3=permute(pos(i-1,j,:)-pos(i,j,:),[1 3 2]);catch; vec3=[];end;
try;vec4=permute(pos(i,j-1,:)-pos(i,j,:),[1 3 2]);catch; vec4=[];end;

try;norm1=cross(vec1,vec2)/norm(cross(vec1,vec2));catch; norm1=[0 0 0];end;
try;norm2=cross(vec2,vec3)/norm(cross(vec2,vec3));catch; norm2=[0 0 0];end;
try;norm3=cross(vec3,vec4)/norm(cross(vec3,vec4));catch; norm3=[0 0 0];end;
try;norm4=cross(vec4,vec1)/norm(cross(vec4,vec1));catch; norm4=[0 0 0];end;
warning on

if sum(isnan(norm1));norm1=[0 0 0];end;
if sum(isnan(norm2));norm2=[0 0 0];end;
if sum(isnan(norm3));norm3=[0 0 0];end;
if sum(isnan(norm4));norm4=[0 0 0];end;

normsum=norm1+norm2+norm3+norm4;

if isequal(norm(normsum),0)
    warning('RJFINDNORMAL: no normal found - setting the normal [1 1 1]');
    normsum=[1 1 1];
end

normal=normsum/norm(normsum);

