function out=rjmakecurve(lengthvector,curvaturefunction,startvector)
%RJMAKECURVE(lengthvector,curvaturefunction)
%Lengthvector is a vector containing the cumulative distance as measured
%along the curve we want to create. Curvaturefunction is a string, eg
%'krok', containing the name of an m-file function that will give the curvature
%as a function of the length.

lvec=lengthvector;
%lvec=0:0.01:1;
%curvaturefunction='planecurvature';
%startvector=[1 0];

lvecnorm=(lvec-min(lvec))/(max(lvec)-min(lvec));
position=zeros(length(lvec),2);
lastvec=(lvec(2)-lvec(1))*startvector/norm(startvector);
position(2,:)=lastvec;


for i=3:length(lvec)
    k=eval([curvaturefunction '(lvecnorm(i))']);
    %k=0.1;
    ds=lvec(i)-lvec(i-1);
    alpha=k*(lvec(i)-lvec(i-1));
    if alpha>pi/2
        alpha=pi/2;
    end
    basevec1=lastvec/norm(lastvec);
    temp=cross([0 0 1],[basevec1 0]);
    basevec2=temp(1:2);
    newvec=ds*(cos(alpha)*basevec1+sin(alpha)*basevec2);
    position(i,:)=position(i-1,:)+newvec;
    lastvec=newvec;
end

%plot(position(:,1),position(:,2));
%axis equal
out=position;











