function [out1,out2,out3]=rjpermute(i1,i2,i3,mode)
%rjpermut    Re-orders and returns the arguments i1,i2 and i3.
%            'mode' is a number that specifies how the re-ordering shall be done
%            This can be useful when one wants to put together several objects
%            in one picture, and easily control how their axes are related to each other
%            Alternatively it can be useful for viewing a composite picture from angles
%            that cannot be specified by view.
%            rjpermut should typically called from one of the rjx-functions connected 
%            to grapical illustrations defined by mr Rickard Jonsson

if exist('mode')==0 | isempty(mode)       mode=1;end

if mode==1
out1=i1;
out2=i2;
out3=i3;
end

if mode==2;
out1=i3;
out2=i1;
out3=i2;
end

if mode==3;
out1=i2;
out2=i3;
out3=i1;
end
    
if mode==4;
out1=i3;
out2=i2;
out3=i1;
end

if mode==5;
out1=i1;
out2=i3;
out3=i2;
end

if mode==6;
out1=i2;
out2=i1;
out3=i3;
end
    
    