function [xnew,ynew]=rjresample(xvec,yvec,number_of_elements)
%RJRESAMPLE(xvec,yvec,number_of_elements)
%
% Resamples a coordinate line to the desired number of elements.
% The elements of the new line are uniformly (in coordinate distance)
% distributed along the line

n=number_of_elements;
le=length(xvec);
xdiff=xvec(2:le)-xvec(1:le-1);
ydiff=yvec(2:le)-yvec(1:le-1);
dist=sqrt(xdiff.^2+ydiff.^2);
cumdistvec=[0 cumsum(dist)]; %The coordinate cumdistvec


maxlength=cumdistvec(length(cumdistvec));
newvec=linspace(0,maxlength,n);
for i=1:n
    xnew(i)=findvalue(newvec(i),cumdistvec,xvec);
    ynew(i)=findvalue(newvec(i),cumdistvec,yvec);
end

