function rjsurfset(handle,surfacecell)
%RJSURFSET(handle,surfacecell)
%  Quicksetting of surface reflection properties  
%  The order is A,D,SS,SE,SC:
%      AmbientStrength
%      DiffuseStrength
%      SpecularStrength
%      SpecularExpontent
%      SpecularColorReflectance
%
%  Example:
%  rjsurfset(h,{0.7,0.3,0.4})

list={'AmbientStrength',...
      'DiffuseStrength',...
      'SpecularStrength',...
      'SpecularExpontent',...
      'SpecularColorReflectance'};

for i=1:length(surfacecell)
    set(handle,list{i},surfacecell{i})
end
