function rjtextproj(handle,image,varargin)

% The default values

default={
    'mode',             1;
    'backgroundcol',    [1 1 1];
    'textcol',          [0 0 0];
    'border',            'off'
};

if rem(length(varargin),2)==1,
   error('RJ: Property value pairs expected.')
end  

opt=rjxoptions(default,varargin);
for i=1:size(default,1)
    eval([default{i,1} '=' 'opt{i}' ';'])
end

%%%%%%%% Here starts the real stuff %%%%%%%%%%%%%%%%%%

if length(colormap)>100000
    disp('RJ: consider colormap([]) before run')
end

a=imread(image);
a=double(a);
if length(size(a))==3
    d=a(:,:,1) + a(:,:,2) + a(:,:,3);
    b= d< (   min(min(d))  +  max(max(d)) )/2;    %The lighter colors are set as background
else
    b= a< (   min(min(a))  +  max(max(a)) )/2;    %If higher than halfways up the colortable, set as background 
end

% so b=0 means background and b=1 means text

if isequal(border,'on')         %This is here to deal with a graphics bugg in Matlab
    s=size(b);
    b=[zeros(1,s(2));b;zeros(1,s(2))];
    b=[zeros(s(1)+2,1) b zeros(s(1)+2,1)];
end

c=rjadd([backgroundcol;textcol]);
C=b+c;

if mode>4;C=fliplr(C);mode=mode-4;end
if mode==2;C=rot90(C,1);end
if mode==3;C=rot90(C,2);end
if mode==4;C=rot90(C,3);end

if isequal( get(handle,'EdgeColor'),'flat' )
    %disp('RJ:Edgecolor should perhaps not be ''flat'' when projecting. Changing to ''none''')
    set(handle,'EdgeColor','none')
end

set(handle,'CData',C,'FaceColor','texturemap')
caxis([1,size(colormap,1)])
