function out=rjxdashsurfline(X,N,varargin)
%RJSURFLINE(X,N,Options)
%
%The options, with default values are:
%
%     'farg',     [0 0 0];
%     'scale',    1;
%     'offset',   [0 0 0];
%     'mode',     1;
%     'az',       []
%     'el',       [];
%     'radius',   [];     
%     'epsilon',  0.01;
%     'startwidth',0.04;
%     'endwidth', 0.1;
%     'arrow',    'on';   %'off', 'curved'
%     'perpmode',  'off'
%     'extend',    0;       % 'on' or non-negative number
%     'startplanenormal', 'off';    % A normal vector
%     'endplanenormal', 'off'       % A normal vector
%     'relarrowlength', 1;          % The relative arrowlength

if rem(length(varargin),2)==1,
   error('RJ: Property value pairs expected.')
end  

default={
    'farg',     [0 0 0];
    'scale',    1;
    'offset',   [0 0 0];
    'mode',     1;
    'az',       []
    'el',       [];
    'radius',   [];     
    'epsilon',  0.01;
    'startwidth',0.04;
    'endwidth', 0.1;
    'arrow',    'on';
    'perpmode',  'off';
%    'extend',    0;         % 'on' or non-negative number
    'startplanenormal', 'off';    % A normal vector
    'endplanenormal', 'off'       % A normal vector
%    'relarrowlength', 1;          % The relative arrowlength
    'dashlength',[];              % Nonempty means dashed line
    'gapfactor',0.3;              % gaplength=gapfactor*dashlength
};

%%% Modifying the default values according to varargin %%%

opt=rjxoptions(default,varargin);

for i=1:size(default,1)
    eval([default{i,1} '=' 'opt{i}' ';'])
end

st=startwidth;
en=endwidth;
to_rjxsurf={'scale',scale,'offset',offset,'mode',mode, ...
        'radius',radius,'epsilon',epsilon,'az',az,'el',el};

%%%%% Fixing stuff related to holding the plot %%%%

initialhold=ishold;
if ~initialhold;clf;end
hold on

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%% The main function starts  %%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

c=rjadd(farg);
normal=N;

%%%%%%%%%%% Delta vector along geodet %%%%%%%%%%%%

le=size(X,1);
pointing=X(2:le,:)-X(1:le-1,:);

%%%% Averaged deltavector, for perpvector %%%%%%%%

body=( X(3:le,:)-X(1:le-2,:) )/2;
first=X(2,:)-X(1,:);
last=X(le,:)-X(le-1,:);
avpointing=[first;body;last];

distance=rjnorm(pointing);
cumdistance=[0 cumsum(distance)];

