function out=rjxrotsurf(r,z,c,varargin)
%RJXROTSURF(r,z,c,Options)
% The default values
%
%     'scale',    1;
%     'offset',   [0 0 0];
%     'mode',     1;
%     'az',       []
%     'el',       [];
%     'radius',   [];     
%     'epsilon',  0.01;
%     'setlines', 'off';
%     'linesep1', 2;
%     'linesep2', 2;
%     'linestyle','y';
%     'linestyle1','';
%     'linestyle2','';
%     'Nphi'      ,40;
%     'farg1'     ,[1 0 0];
%     'farg2'     ,[0 1 0];
%     'farg'      ,[]

default={
    'scale',    1;
    'offset',   [0 0 0];
    'mode',     1;
    'az',       []
    'el',       [];
    'radius',   [];     
    'epsilon',  0.01;
    'setlines', 'off';
    'linesep1', 2;
    'linesep2', 2;
    'linestyle','y';
    'linestyle1','';
    'linestyle2','';
    'Nphi'      ,40;
    'farg1'     ,[1 0 0];
    'farg2'     ,[0 1 0];
    'farg'      ,[];
    'getsurf', 'off';   %Outputs not only handle, but X,Y,Z,phi
    'reverse','off';    %Reverses the direction of phi
    'rotangle',0;       %An offset rotation angle
    'col', [];          %Overrules farg
    'linecol', [];
    'phimax', 2*pi;
    'rollfactor',0;
    'eyeset',{[],[],[]};%Overrules az, el, radius
    'flipsurf','off';   %Z goes to -Z if 'on'
 };

eval(setvalues)

if ~isempty(col)
    farg=col;
end

if ~isempty(eyeset{1})
    az=eyeset{1};el=eyeset{2};radius=eyeset{3};
end

%%%%  The stuff to send along                 %%%%%%%%%%%%%%%
%%%% (This Can be done more cleverly but what the heck :) %%%

to_rjxsurf={...
    'scale',  scale,...
    'offset', offset ,... 
    'mode',   mode ,... 
    'az',     az,...  
    'el',     el,...  
    'radius', radius ,...    
    'epsilon', epsilon ,...
    'setlines', setlines,...
    'linesep1', linesep1,...
    'linesep2', linesep2,...
    'linestyle',linestyle,...
    'linestyle1',linestyle1,...
    'linestyle2',linestyle2,...
    'linecol',linecol,...
};

%%%%%%%% Making row vectors if necessary %%%%%%%%%%

if size(r,1)>size(r,2);r=r';end
if size(z,1)>size(z,2);z=z';end
if size(c,1)>size(c,2);c=c';end
if ~isequal(size(r,2),size(z,2),size(c,2))
    error('RJ: r,z,c have different number of elements');
end

%%%% The real stuff %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

phi=linspace(0,phimax,Nphi+1)+rotangle;   

X=r'*(cos(phi).*(1+rollfactor*phi));    %X is a matrix
Y=r'*(sin(phi).*(1+rollfactor*phi));    %Y is a matrix
if isequal(reverse,'on')
    disp('This effect was altered 4/4-03 to include rollfactor')
    X=r'*(cos(-phi).*(1+rollfactor*(phi)));    %X is a matrix
    Y=r'*(sin(-phi).*(1+rollfactor*(phi)));    %Y is a matrix
end

for i=1:Nphi+1
Z(:,i)=z';        %Z is a matrix
C(:,i)=c';
end

if isempty(farg)
    farg=[farg1;farg2];
end

c1=rjadd(farg);
C=C-min(min(C)) + c1;

if isequal(flipsurf,'on')
    Z=-Z;
end

h=rjxsurf(X,Y,Z,C,'settings',to_rjxsurf);

%%%% Outputting values %%%%%%%%%%%%%%%%%%%%%%

if ~isequal(getsurf,'on')
    out=h;
else
    out={h,X,Y,Z,phi};
end














